#pragma once


class EffectSprite : public GameObject
{
public:
	EffectSprite( Level& level )
		:
	GameObject( level )
	{
	}

	void update()
	{
		x+= dx;
		y+= dy;
		rot+= drot;
		dy+= g;
		age+= 0.01f;

		if( age > maxage )
		{
			dead= true;
		}
	}
	
	void render()
	{
		float alpha = 1.0f - age / maxage;
		float fScale= 2.0f - alpha;
		alpha= min( alpha, age / maxage * 1.0f );
		if(alpha > 1.0f) alpha = 1.0f;
		else if(alpha < 0.0f) alpha = 0.0f;
		hgeColor color(1.0f, 1.0f, 1.0f, alpha);
		sprSprite->SetColor(color.GetHWColor());
		sprSprite->RenderEx(x, y, rot, scale * fScale );
	}

//private:
	float x, y, rot;
	float dx, dy, drot;
	float g;
	float age, maxage;
	float scale;
	hgeColor color;

	hgeSprite*	sprSprite;
	
};