/*
** Haaf's Game Engine 1.7
** Copyright (C) 2003-2007, Relish Games
** hge.relishgames.com
**
** hge_tut03 - Using helper classes
*/


// Copy the files "particles.png", "menu.wav",
// "font1.fnt", "font1.png" and "trail.psi" from
// the folder "precompiled" to the folder with
// executable file. Also copy hge.dll and bass.dll
// to the same folder.

#include "pch.h"

#include <string>
#include <ctime>

//#include "..\..\include\hge.h"
//#include "..\..\include\hgesprite.h"
//#include "..\..\include\hgefont.h"
//#include "..\..\include\hgeparticle.h"


// Pointer to the HGE interface.
// Helper classes require this to work.
#include "gfx.h"
#include "sfx.h"
#include "Level.h"

//HEFFECT				snd;

#include "globals.h"

// Play sound effect
void boom()
{
	//int pan=int((x-400)/4);
	//float pitch=(dx*dx+dy*dy)*0.0005f+0.2f;
	//hge->Effect_PlayEx(snd,100,pan,pitch);
}

#include "frame.h"

#include "render.h"


int WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	g_hge = hgeCreate(HGE_VERSION);
	srand( (unsigned int)time( NULL ) );
	g_hge->Random_Seed( (int)time( NULL ));

	g_hge->System_SetState(HGE_SHOWSPLASH, false);
	g_hge->System_SetState(HGE_LOGFILE, "das.log");
	g_hge->System_SetState(HGE_FRAMEFUNC, FrameFunc);
	g_hge->System_SetState(HGE_RENDERFUNC, RenderFunc);
	g_hge->System_SetState(HGE_TITLE, "einprojektdasluft");
	g_hge->System_SetState(HGE_FPS, 100);
	g_hge->System_SetState(HGE_WINDOWED, false);
	g_hge->System_SetState(HGE_SCREENWIDTH, (int)g_fScreenSizeX );
	g_hge->System_SetState(HGE_SCREENHEIGHT, (int)g_fScreenSizeY );
	g_hge->System_SetState(HGE_SCREENBPP, 32);

	if(g_hge->System_Initiate())
	{
		loadAllGFX();
		loadAllSFX();
		g_Level = new Level;

		g_hge->Music_Play(g_musGame, true);

		// Load sound and texture
		//snd=hge->Effect_Load("menu.wav");
		
		// Load a font
		//fnt=new hgeFont("font1.fnt");

		// Create and set up a particle system
		//spt=new hgeSprite(tex, 32, 32, 32, 32);
		//spt->SetBlendMode(BLEND_COLORMUL | BLEND_ALPHAADD | BLEND_NOZWRITE);
		//spt->SetHotSpot(16,16);
		//par=new hgeParticleSystem("trail.psi",spt);
		//par->Fire();

		// Let's rock now!
		g_hge->System_Start();

		// Delete created objects and free loaded resources
	}

	unloadAllGFX();
	unloadAllSFX();

	// Clean up and shutdown
	g_hge->System_Shutdown();
	g_hge->Release();
	return 0;
}
