#include "pch.h"

#include "gfx.h"
#include "Player.h"
#include "Level.h"
#include "Field.h"
#include "sfx.h"

CPlayerShip::CPlayerShip( Level& level )
:
GameObject( level ),
m_tvX( 0.0f, 0.0f, 0.0f, 0.02f, 0.85f ),
m_tvY( 0.0f, 0.0f, 0.0f, 0.02f, 0.85f )
{
}

void CPlayerShip::update()
{
	m_tvX.timeStep();
	m_tvY.timeStep();

	float fStackingFlow= 2.0f;
	float fMinDiff= 32.0f;

		for( int i= 0; i< (int)m_FieldStack.size(); ++i )
	{
		m_FieldStack[ i ]->update();
	}

	m_iLayer= g_PlayerShipDepth + (int)m_fDepth;


	if( level.m_bGameOver )
	{
		return;
	}

	if( g_hge->Input_KeyDown( m_iKeyLeft ) && level.m_bFUCKHGE ) 
	{
		if( m_iRow > 0 )
		{
			float fLevelHeight= level.GetLowestPos( m_iRow - 1 );
			float fStackHeight= m_fY + m_fDepth - g_fBlockHeight * ( m_FieldStack.size() + 1 );
			if( fLevelHeight < fStackHeight - fMinDiff )
			{
				m_iRow--;
				m_tvX.m_fValue+= g_fBlockWidth;

				for( int i= 0; i< (int)m_FieldStack.size(); ++i )
				{
					m_FieldStack[ i ]->m_tvX.m_fValue+= i * fStackingFlow;
				}
			}

		}
	}
	if( g_hge->Input_KeyDown( m_iKeyRight ) && level.m_bFUCKHGE ) 
	{
		if( m_iRow < LEVEL_WIDTH - 1 )
		{
			float fLevelHeight= level.GetLowestPos( m_iRow + 1 );
			float fStackHeight= m_fY + m_fDepth - g_fBlockHeight * ( m_FieldStack.size() + 1 );
			if( fLevelHeight < fStackHeight - fMinDiff )
			{
				m_iRow++;
				m_tvX.m_fValue-= g_fBlockWidth;

				for( int i= 0; i< (int)m_FieldStack.size(); ++i )
				{
					m_FieldStack[ i ]->m_tvX.m_fValue-= i * fStackingFlow;
				}
			}
		}
	}

	float realX = m_tvX.m_fValue + m_fX + g_fBlockWidth * (float)m_iRow;
	int pan = calcPan(realX);

	if( g_hge->Input_KeyDown( m_iKeyDown ) && level.m_bFUCKHGE ) 
	{
		if( c_iMaxStackSize > m_FieldStack.size() && m_iColor == level.LowestPlayer( m_iRow ) )
		{
			float fPosY; 
			Field* pTaken= level.GetLowestFromRow( m_iRow, fPosY );
			if( pTaken != NULL )
			{
				m_FieldStack.push_back( pTaken );
				float realY = m_tvY.m_fValue + m_fY + m_fDepth;
				pTaken->m_tvY.m_fValue-= realY - fPosY - g_fBlockHeight * ( m_FieldStack.size() + 1 );

		
				level.movePlayerDown( m_iColor );

				g_hge->Effect_PlayEx(g_sndTakeBlock, 100, pan, g_hge->Random_Float(0.8f, 1.2f));
			}
		}
	}

	if( g_hge->Input_KeyDown( m_iKeyUp ) && level.m_bFUCKHGE ) 
	{
		for( int i= (int) m_FieldStack.size() - 1; i >= 0; --i )
		{
			
			Field* pTaken= m_FieldStack[ i ];
			if( pTaken != NULL )
			{
				//m_FieldStack.push_back( pTaken );
				//float realY = m_tvY.m_fValue + m_fY + m_fDepth;
				//pTaken->m_tvY.m_fValue-= realY - fPosY - g_fBlockHeight * ( m_FieldStack.size() + 1 );

				float fPosY= m_tvY.m_fValue + m_fY + m_fDepth - g_fBlockHeight * ( i ); 
				level.putBack( m_iRow, pTaken, fPosY );

				g_hge->Effect_PlayEx(g_sndPutBlock, 100, pan, g_hge->Random_Float(0.8f, 1.2f));
			}
		}
		m_FieldStack.clear();
	}

}

void CPlayerShip::render()
{
	
	float realX = m_tvX.m_fValue + m_fX + g_fBlockWidth * (float)m_iRow;
	float realY = m_tvY.m_fValue + m_fY + m_fDepth;
	float fLevelPos= level.GetLowestPos( m_iRow ) + m_FieldStack.size() * g_fBlockHeight + 64.0f;
	realY= max( fLevelPos, realY );
	g_sprPlayer[ m_iColor ]->Render(realX, realY);

	for( int i= 0; i< (int)m_FieldStack.size(); ++i )
	{
		realY-= g_fBlockHeight;
		m_FieldStack[ i ]->render( realX, realY );
	}
}