#include "PCH.h"
#include "Text.h"
#include "gfx.h"

Text::Text(Level& level, const std::string& text, float x, float y, float size, const hgeColor& color, float lifetime)
	: GameObject(level), text(text), x(x), y(y), size(size), color(color), lifetime(lifetime), age(0.0f)
{
	m_iLayer = g_TextDepth;
}

Text::~Text()
{

}

void Text::update()
{
	age += 0.01f;
	if(age > lifetime) dead = true;
}

void Text::render()
{
	float lifetimeLeft = lifetime - age;
	float viewSize = size;
	hgeColor viewColor = color;

	if(lifetimeLeft < 1.0f)
	{
		float t = 1.0f - lifetimeLeft;
		viewSize *= 1.0f + t * t;
		viewColor.a -= t;
	}

	g_fntBig->SetScale(viewSize);
	g_fntBig->SetColor(hgeColor(0.0f, 0.0f, 0.0f, viewColor.a * 0.5f).GetHWColor());
	g_fntBig->Render(x - 0.01f * viewSize, y - 0.01f * viewSize, HGETEXT_CENTER | HGETEXT_MIDDLE, text.c_str());
	g_fntBig->SetColor(viewColor.GetHWColor());
	g_fntBig->Render(x, y, HGETEXT_CENTER | HGETEXT_MIDDLE, text.c_str());
}